<?php

Class Parser
{
	public $urls_passed=array();
	
	public function Inspect($url)
	{
		log::AddLine('  ' . $url);
		
		$this->urls_passed[] = $url;
		
		print $url . "\r\n";
		
		$contents = fsocket::Send($url);
		
		/* 
		**  _    =)
		**    isSet  isset
		*/
		$vasa_c = preg_split('~(\r\n\r\n)|(\n\r\n\r)|(\n\n)|(\r\r)~', $contents, 2);
		$headers = $vasa_c[0];
		$contents = isset($vasa_c[1]) ? $vasa_c[1] : '';
		
		log::AddLine("  -  ,    ");
		fsocket::$cookies .= fsocket::GetCookies($headers);
		$location_redirect = fsocket::GetLocation($headers);
		
		print $location_redirect;
		
		
		if (!$location_redirect)
		{
			log::AddLine("  -   ,     ");
			
			$target = self::GetTarget($contents);
				
			if ($target)
			{
				log::AddLine("  -  ! ! =)");
				log::RecordTarget($url, $target);
			}
			
			
			$links = self::DetectAllLinks($contents);

			if ($links)
			{
				log::AddLine("  - ,    !    !");
				foreach($links as $link)
				{
					if (self::IsInternal($link))
					{
						//$sublink = self::PrepareUrl($link);
						//$this->Inspect($sublink);
					}
				}
			}
		}
		else
		{
			if (self::IsInternal($location_redirect))
			{
				//$location_redirect = self::PrepareUrl($location_redirect);
				log::AddLine("  -     : " . $location_redirect);
				
				$location_redirect = trim($location_redirect);
				
				if (!in_array($location_redirect, $this->urls_passed))
				{
					log::AddLine("  -     ,    ");
					$this->Inspect($location_redirect);
				}
			}
		}
		
	}

	public static function DetectAllLinks($contents)
	{
		preg_match_all('#<a.*?href="(.*?)".*?>.*?</a>#is', $contents, $m);
		
		//print_r($m);
		
		if (!empty($m))
		{
			return($m[1]);
		}
		else
		{
			return(false);
		}
	}
	
	
	public static function IsInternal($url)
	{
		$parse = parse_url($url);
		
		if (isset($parse['scheme']))
		{
			if (isset($parse['host']) && $parse['host'] != 'pyha.ru')
			{
				return(false);
			}
		}
		
		return(true);
	}
	
	public static function PrepareUrl()
	{
		
	}
	
	public static function GlueUrl($parsed)
	{
	    if (!is_array($parsed)) return false;
	    $uri = isset($parsed['scheme']) ? $parsed['scheme'].':'.((strtolower($parsed['scheme']) == 'mailto') ? '' : '//') : '';
	    $uri .= isset($parsed['user']) ? $parsed['user'].(isset($parsed['pass']) ? ':'.$parsed['pass'] : '').'@' : '';
	    $uri .= isset($parsed['host']) ? $parsed['host'] : '';
	    $uri .= isset($parsed['port']) ? ':'.$parsed['port'] : '';
	    if(isset($parsed['path']))
	    {
	        $uri .= (substr($parsed['path'], 0, 1) == '/') ? $parsed['path'] : ('/'.$parsed['path']);
	    }
	    $uri .= isset($parsed['query']) ? '?'.$parsed['query'] : '';
	    $uri .= isset($parsed['fragment']) ? '#'.$parsed['fragment'] : '';
	    return $uri;
	}
	
	
	public static function GetTarget($contents)
	{
		preg_match('#<div.*?id="content".*?>(.*?)</div>#is', $contents, $m);
		
		if (!empty($m))
		{
			return($m[1]);
		}
		else
		{
			return(false);
		}
	}
	
}

?>